=== debian/changelog ===
swiftlang (5.6.3-3) unstable; urgency=medium

  * Enable more parallel building.
  * d/control - Add binutils and gcc to depends. (Closes: #1057117)
  * d/control - Add binutils-dev to build depends.
  * d/po - Add es.po (Closes: #1057468)
  * d/po - Add nl.po (Closes: #1058634)

  [ Sylvestre Ledru ]
  * d/po - Add de.po (Closes: #1059351)
    Thanks Helge Kreutzmann for the trad

 -- Steve Meliza <swm@swm1.com>  Tue, 19 Dec 2023 17:50:58 -0800

swiftlang (5.6.3-2) unstable; urgency=low

  * d/rules - Fix chmod when paths don't exist.

 -- Steve Meliza <swm@swm1.com>  Thu, 23 Nov 2023 20:23:22 -0800

swiftlang (5.6.3-1) unstable; urgency=low

  * Fix amd64 and arm64 architecture build errors.
  * Fixes to d/copyright

 -- Steve Meliza <swm@swm1.com>  Thu, 09 Nov 2023 22:03:36 -0800

swiftlang (5.6.3-1~exp2) experimental; urgency=medium

  * Add patches to fix architecture build errors.
  * debian/control: Change supported architectures.

 -- Steve Meliza <swm@swm1.com>  Tue, 24 Oct 2023 17:36:52 -0700

swiftlang (5.6.3-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #788327)

 -- Steve Meliza <swm@swm1.com>  Mon, 04 Sep 2023 10:54:33 -0700
