=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%" \
https://api.github.com/repos/apple/swift/releases?per_page=50 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?swift-@ANY_VERSION@-RELEASE
